int maxCount = 30;
int currentCount = 1;
Sphere[] spheres = new Sphere[maxCount];

float a =0;
float distance = 100;
boolean wantNew = false;
boolean makeVideo = false;

void setup() {
  size(1366, 768, P3D);
  background(0);
  spheres[0] = new Sphere();
  spheres[0].sColor = new PVector(255, 0, 0);
}

void draw() {
  lights();
  blendMode(SUBTRACT);
  fill(3);
  rect(0, 0, width, height);
  blendMode(BLEND);
  
  translate(width/2, height/2, distance);
  rotateZ(a);
  rotateX(0.8 * a);
  //rotateY(0.2 * a);
  
  if(currentCount < maxCount && wantNew) {
    Sphere newSphere = new Sphere();
    float smallestDist = 100000000;
    for(int i=0; i < currentCount; i++) {
      float newDist = dist(newSphere.x, newSphere.y, newSphere.z, spheres[i].x, spheres[i].y, spheres[i].z);
      if(newDist < smallestDist) smallestDist = newDist;
    }
    if(smallestDist > 30) {
      spheres[currentCount] = newSphere;
      float dist = dist(newSphere.x, newSphere.y, newSphere.z, 0, 0, 0);
      spheres[currentCount].sColor = new PVector(dist % 200 + 55, 0, 0);
      currentCount++;
      print(currentCount + ", ");
    }
    wantNew = false;
  }
  
  for(int i = 0; i < currentCount; i++) {
    pushMatrix();

    spheres[i].show();
    
    //stroke(random(30, 255), random(30, 255), random(30, 255), 50);
    stroke(255, 50);
    strokeWeight(1);
    popMatrix();
    for(int j=0; j < currentCount; j++) {
      line(spheres[i].x, spheres[i].y, spheres[i].z, spheres[j].x, spheres[j].y, spheres[j].z);
    }
  }
  a += 0.01;
  if(makeVideo) {
    saveFrame("video####.png");
  }
}

void keyPressed() {
  if(key == 'k' || key == 'K') wantNew = true;
  if(key == 's' || key == 'S') saveFrame("Frame_####.png");
  if(key == 'v' || key == 'V') makeVideo = !makeVideo;
  if(key == 'm' || key == 'M') distance += 10;
  if(key == 'n' || key == 'N') distance -= 10;
}